Subject: bug#50979: "home configuration" generated by "guix home import" does not lead to a reproducible home environment

From: Maxime Devos <[email-masked]>
Date: Sat, 02 Oct 2021 22:11:39 +0200

Hi,

I ran "guix home import".  The output seems mostly reasonable, but the use
of 'local-file' seems troublesome:

;; [comments] 
(use-modules [modules])

(home-environment
  (packages [stuff])
  (services
    (list (service
            home-bash-service-type
            (home-bash-configuration
              (bashrc
                (list (slurp-file-gexp
                        (local-file "/home/[USER]/.bashrc"))))
              (bash-profile
                (list (slurp-file-gexp
                        (local-file "/home/[USER]/.bash_profile")))))))))

IIUC, when I will run "guix home reconfigure", guix home will intern
~/.bashrc and ~/.bash_profile in the store, build things, and eventually
replace ~/.bashrc with some symlink to something in the store.

I assume this technically all works out, but this seems a bit irreproducible.
What I made modifications to ~/.bash_profile?  It seems like, if I run "guix home reconfigure"
on the same system, the modifications will be preserved, which is fine.  However,
what if I log into another system, copy the home configuration, and run "guix home reconfigure"
from there?   Then "guix home reconfigure" would pick up the ~/.bash_profile from the new system
(without the modifications) instead of the old system, right?

Then the home configuration generated by "guix home import" isn't self-contained,
which seems unfortunate.

Two proposals for addressing the issue:

  (1) Use 'plain-file' instead of 'local-file', to include the contents of ~/.bashrc inside
      the generated configuration

  (2) Let "guix home import" create a directory with the "home-environment.scm", ".bashrc"
      and ".bash_profile".

Greetings,
Maxime